CfnOrganizationConfigRule L1 construct
Adds or updates an AWS Config rule for your entire organization to evaluate if your AWS resources comply with your desired configurations.
For information on how many organization AWS Config rules you can have per account, see Service Limits in the AWS Config Developer Guide .
Only a management account and a delegated administrator can create or update an organization AWS Config rule. When calling the OrganizationConfigRule resource with a delegated administrator, you must ensure AWS Organizations ListDelegatedAdministrator permissions are added. An organization can have up to 3 delegated administrators.
The OrganizationConfigRule resource enables organization service access through the EnableAWSServiceAccess action and creates a service-linked role AWSServiceRoleForConfigMultiAccountSetup in the management or delegated administrator account of your organization. The service-linked role is created only when the role does not exist in the caller account. AWS Config verifies the existence of role with GetRole action.
To use the OrganizationConfigRule resource with delegated administrator, register a delegated administrator by calling AWS Organization register-delegated-administrator for config-multiaccountsetup.amazonaws.com .
There are two types of rules: AWS Config Managed Rules and AWS Config Custom Rules . You can use PutOrganizationConfigRule to create both AWS Config Managed Rules and AWS Config Custom Rules.
AWS Config Managed Rules are predefined, customizable rules created by AWS Config . For a list of managed rules, see List of AWS Config Managed Rules . If you are adding an AWS Config managed rule, you must specify the rule's identifier for the RuleIdentifier key.
AWS Config Custom Rules are rules that you create from scratch. There are two ways to create AWS Config custom rules: with Lambda functions ( AWS Lambda Developer Guide ) and with Guard ( Guard GitHub Repository ), a policy-as-code language. AWS Config custom rules created with AWS Lambda are called AWS Config Custom Lambda Rules and AWS Config custom rules created with Guard are called AWS Config Custom Policy Rules .
If you are adding a new AWS Config Custom Lambda rule, you first need to create an AWS Lambda function in the management account or a delegated administrator that the rule invokes to evaluate your resources. You also need to create an IAM role in the managed account that can be assumed by the Lambda function. When you use PutOrganizationConfigRule to add a Custom Lambda rule to AWS Config , you must specify the Amazon Resource Name (ARN) that AWS Lambda assigns to the function.
Example
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_config as config } from 'aws-cdk-lib';
const cfnOrganizationConfigRule = new config.CfnOrganizationConfigRule(this, 'MyCfnOrganizationConfigRule', {
organizationConfigRuleName: 'organizationConfigRuleName',
// the properties below are optional
excludedAccounts: ['excludedAccounts'],
organizationCustomPolicyRuleMetadata: {
policyText: 'policyText',
runtime: 'runtime',
// the properties below are optional
debugLogDeliveryAccounts: ['debugLogDeliveryAccounts'],
description: 'description',
inputParameters: 'inputParameters',
maximumExecutionFrequency: 'maximumExecutionFrequency',
organizationConfigRuleTriggerTypes: ['organizationConfigRuleTriggerTypes'],
resourceIdScope: 'resourceIdScope',
resourceTypesScope: ['resourceTypesScope'],
tagKeyScope: 'tagKeyScope',
tagValueScope: 'tagValueScope',
},
organizationCustomRuleMetadata: {
lambdaFunctionArn: 'lambdaFunctionArn',
organizationConfigRuleTriggerTypes: ['organizationConfigRuleTriggerTypes'],
// the properties below are optional
description: 'description',
inputParameters: 'inputParameters',
maximumExecutionFrequency: 'maximumExecutionFrequency',
resourceIdScope: 'resourceIdScope',
resourceTypesScope: ['resourceTypesScope'],
tagKeyScope: 'tagKeyScope',
tagValueScope: 'tagValueScope',
},
organizationManagedRuleMetadata: {
ruleIdentifier: 'ruleIdentifier',
// the properties below are optional
description: 'description',
inputParameters: 'inputParameters',
maximumExecutionFrequency: 'maximumExecutionFrequency',
resourceIdScope: 'resourceIdScope',
resourceTypesScope: ['resourceTypesScope'],
tagKeyScope: 'tagKeyScope',
tagValueScope: 'tagValueScope',
},
});
# The code below shows an example of how to instantiate this type.
# The values are placeholders you should change.
from aws_cdk import aws_config as config
cfn_organization_config_rule = config.CfnOrganizationConfigRule(self, "MyCfnOrganizationConfigRule",
organization_config_rule_name="organizationConfigRuleName",
# the properties below are optional
excluded_accounts=["excludedAccounts"],
organization_custom_policy_rule_metadata=config.CfnOrganizationConfigRule.OrganizationCustomPolicyRuleMetadataProperty(
policy_text="policyText",
runtime="runtime",
# the properties below are optional
debug_log_delivery_accounts=["debugLogDeliveryAccounts"],
description="description",
input_parameters="inputParameters",
maximum_execution_frequency="maximumExecutionFrequency",
organization_config_rule_trigger_types=["organizationConfigRuleTriggerTypes"],
resource_id_scope="resourceIdScope",
resource_types_scope=["resourceTypesScope"],
tag_key_scope="tagKeyScope",
tag_value_scope="tagValueScope"
),
organization_custom_rule_metadata=config.CfnOrganizationConfigRule.OrganizationCustomRuleMetadataProperty(
lambda_function_arn="lambdaFunctionArn",
organization_config_rule_trigger_types=["organizationConfigRuleTriggerTypes"],
# the properties below are optional
description="description",
input_parameters="inputParameters",
maximum_execution_frequency="maximumExecutionFrequency",
resource_id_scope="resourceIdScope",
resource_types_scope=["resourceTypesScope"],
tag_key_scope="tagKeyScope",
tag_value_scope="tagValueScope"
),
organization_managed_rule_metadata=config.CfnOrganizationConfigRule.OrganizationManagedRuleMetadataProperty(
rule_identifier="ruleIdentifier",
# the properties below are optional
description="description",
input_parameters="inputParameters",
maximum_execution_frequency="maximumExecutionFrequency",
resource_id_scope="resourceIdScope",
resource_types_scope=["resourceTypesScope"],
tag_key_scope="tagKeyScope",
tag_value_scope="tagValueScope"
)
)
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import software.amazon.awscdk.services.config.*;
CfnOrganizationConfigRule cfnOrganizationConfigRule = CfnOrganizationConfigRule.Builder.create(this, "MyCfnOrganizationConfigRule")
.organizationConfigRuleName("organizationConfigRuleName")
// the properties below are optional
.excludedAccounts(List.of("excludedAccounts"))
.organizationCustomPolicyRuleMetadata(OrganizationCustomPolicyRuleMetadataProperty.builder()
.policyText("policyText")
.runtime("runtime")
// the properties below are optional
.debugLogDeliveryAccounts(List.of("debugLogDeliveryAccounts"))
.description("description")
.inputParameters("inputParameters")
.maximumExecutionFrequency("maximumExecutionFrequency")
.organizationConfigRuleTriggerTypes(List.of("organizationConfigRuleTriggerTypes"))
.resourceIdScope("resourceIdScope")
.resourceTypesScope(List.of("resourceTypesScope"))
.tagKeyScope("tagKeyScope")
.tagValueScope("tagValueScope")
.build())
.organizationCustomRuleMetadata(OrganizationCustomRuleMetadataProperty.builder()
.lambdaFunctionArn("lambdaFunctionArn")
.organizationConfigRuleTriggerTypes(List.of("organizationConfigRuleTriggerTypes"))
// the properties below are optional
.description("description")
.inputParameters("inputParameters")
.maximumExecutionFrequency("maximumExecutionFrequency")
.resourceIdScope("resourceIdScope")
.resourceTypesScope(List.of("resourceTypesScope"))
.tagKeyScope("tagKeyScope")
.tagValueScope("tagValueScope")
.build())
.organizationManagedRuleMetadata(OrganizationManagedRuleMetadataProperty.builder()
.ruleIdentifier("ruleIdentifier")
// the properties below are optional
.description("description")
.inputParameters("inputParameters")
.maximumExecutionFrequency("maximumExecutionFrequency")
.resourceIdScope("resourceIdScope")
.resourceTypesScope(List.of("resourceTypesScope"))
.tagKeyScope("tagKeyScope")
.tagValueScope("tagValueScope")
.build())
.build();
// Install: dotnet add package Amazon.CDK.Lib
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
using Amazon.CDK.AWS.Config;
var cfnOrganizationConfigRule = new CfnOrganizationConfigRule(this, "MyCfnOrganizationConfigRule", new CfnOrganizationConfigRuleProps {
OrganizationConfigRuleName = "organizationConfigRuleName",
// the properties below are optional
ExcludedAccounts = new [] { "excludedAccounts" },
OrganizationCustomPolicyRuleMetadata = new OrganizationCustomPolicyRuleMetadataProperty {
PolicyText = "policyText",
Runtime = "runtime",
// the properties below are optional
DebugLogDeliveryAccounts = new [] { "debugLogDeliveryAccounts" },
Description = "description",
InputParameters = "inputParameters",
MaximumExecutionFrequency = "maximumExecutionFrequency",
OrganizationConfigRuleTriggerTypes = new [] { "organizationConfigRuleTriggerTypes" },
ResourceIdScope = "resourceIdScope",
ResourceTypesScope = new [] { "resourceTypesScope" },
TagKeyScope = "tagKeyScope",
TagValueScope = "tagValueScope"
},
OrganizationCustomRuleMetadata = new OrganizationCustomRuleMetadataProperty {
LambdaFunctionArn = "lambdaFunctionArn",
OrganizationConfigRuleTriggerTypes = new [] { "organizationConfigRuleTriggerTypes" },
// the properties below are optional
Description = "description",
InputParameters = "inputParameters",
MaximumExecutionFrequency = "maximumExecutionFrequency",
ResourceIdScope = "resourceIdScope",
ResourceTypesScope = new [] { "resourceTypesScope" },
TagKeyScope = "tagKeyScope",
TagValueScope = "tagValueScope"
},
OrganizationManagedRuleMetadata = new OrganizationManagedRuleMetadataProperty {
RuleIdentifier = "ruleIdentifier",
// the properties below are optional
Description = "description",
InputParameters = "inputParameters",
MaximumExecutionFrequency = "maximumExecutionFrequency",
ResourceIdScope = "resourceIdScope",
ResourceTypesScope = new [] { "resourceTypesScope" },
TagKeyScope = "tagKeyScope",
TagValueScope = "tagValueScope"
}
});
// Install: go get github.com/aws/aws-cdk-go/awscdk/v2
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import "github.com/aws/aws-cdk-go/awscdk"
cfnOrganizationConfigRule := awscdk.Aws_config.NewCfnOrganizationConfigRule(this, jsii.String("MyCfnOrganizationConfigRule"), &CfnOrganizationConfigRuleProps{
OrganizationConfigRuleName: jsii.String("organizationConfigRuleName"),
// the properties below are optional
ExcludedAccounts: []*string{
jsii.String("excludedAccounts"),
},
OrganizationCustomPolicyRuleMetadata: &OrganizationCustomPolicyRuleMetadataProperty{
PolicyText: jsii.String("policyText"),
Runtime: jsii.String("runtime"),
// the properties below are optional
DebugLogDeliveryAccounts: []*string{
jsii.String("debugLogDeliveryAccounts"),
},
Description: jsii.String("description"),
InputParameters: jsii.String("inputParameters"),
MaximumExecutionFrequency: jsii.String("maximumExecutionFrequency"),
OrganizationConfigRuleTriggerTypes: []*string{
jsii.String("organizationConfigRuleTriggerTypes"),
},
ResourceIdScope: jsii.String("resourceIdScope"),
ResourceTypesScope: []*string{
jsii.String("resourceTypesScope"),
},
TagKeyScope: jsii.String("tagKeyScope"),
TagValueScope: jsii.String("tagValueScope"),
},
OrganizationCustomRuleMetadata: &OrganizationCustomRuleMetadataProperty{
LambdaFunctionArn: jsii.String("lambdaFunctionArn"),
OrganizationConfigRuleTriggerTypes: []*string{
jsii.String("organizationConfigRuleTriggerTypes"),
},
// the properties below are optional
Description: jsii.String("description"),
InputParameters: jsii.String("inputParameters"),
MaximumExecutionFrequency: jsii.String("maximumExecutionFrequency"),
ResourceIdScope: jsii.String("resourceIdScope"),
ResourceTypesScope: []*string{
jsii.String("resourceTypesScope"),
},
TagKeyScope: jsii.String("tagKeyScope"),
TagValueScope: jsii.String("tagValueScope"),
},
OrganizationManagedRuleMetadata: &OrganizationManagedRuleMetadataProperty{
RuleIdentifier: jsii.String("ruleIdentifier"),
// the properties below are optional
Description: jsii.String("description"),
InputParameters: jsii.String("inputParameters"),
MaximumExecutionFrequency: jsii.String("maximumExecutionFrequency"),
ResourceIdScope: jsii.String("resourceIdScope"),
ResourceTypesScope: []*string{
jsii.String("resourceTypesScope"),
},
TagKeyScope: jsii.String("tagKeyScope"),
TagValueScope: jsii.String("tagValueScope"),
},
})
Initializer
new CfnOrganizationConfigRule(scope: Construct, id: string, props: CfnOrganizationConfigRuleProps)
CfnOrganizationConfigRule(scope: Construct, id: str, props: CfnOrganizationConfigRuleProps)
new CfnOrganizationConfigRule(Construct scope, String id, CfnOrganizationConfigRuleProps props)
new CfnOrganizationConfigRule(Construct scope, string id, CfnOrganizationConfigRuleProps props)
NewCfnOrganizationConfigRule(Scope Construct, Id *string, Props CfnOrganizationConfigRuleProps)
Construct Props
excludedAccountsstring[]excluded_accountstyping.List[str]excludedAccountsList<String>ExcludedAccountsstring[]ExcludedAccounts*[]*string#organizationConfigRuleNamestringorganization_config_rule_namestrorganizationConfigRuleNameStringOrganizationConfigRuleNamestringOrganizationConfigRuleName*stringrequired#organizationCustomPolicyRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationCustomPolicyRuleMetadataPropertyorganization_custom_policy_rule_metadatatyping.Union[IResolvable, OrganizationCustomPolicyRuleMetadataProperty]organizationCustomPolicyRuleMetadataIResolvableOrganizationCustomPolicyRuleMetadataIResolvableOrganizationCustomPolicyRuleMetadatainterface{}#notes
The metadata includes the runtime system in use, which accounts have debug logging enabled, and other custom rule metadata, such as resource type, resource ID of AWS resource, and organization trigger types that initiate AWS Config to evaluate AWS resources against a rule.
organizationCustomRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationCustomRuleMetadataPropertyorganization_custom_rule_metadatatyping.Union[IResolvable, OrganizationCustomRuleMetadataProperty]organizationCustomRuleMetadataIResolvableOrganizationCustomRuleMetadataIResolvableOrganizationCustomRuleMetadatainterface{}#organizationManagedRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationManagedRuleMetadataPropertyorganization_managed_rule_metadatatyping.Union[IResolvable, OrganizationManagedRuleMetadataProperty]organizationManagedRuleMetadataIResolvableOrganizationManagedRuleMetadataIResolvableOrganizationManagedRuleMetadatainterface{}#Properties
attrOrganizationConfigRuleArnstringattr_organization_config_rule_arnstrattrOrganizationConfigRuleArnStringAttrOrganizationConfigRuleArnstringAttrOrganizationConfigRuleArn*stringrequired#CFN_RESOURCE_TYPE_NAMEstringcfn_resource_type_namestrCFN_RESOURCE_TYPE_NAMEStringCFN_RESOURCE_TYPE_NAMEstringCFN_RESOURCE_TYPE_NAME*stringrequiredstatic#cfnOptionsICfnResourceOptionscfn_optionsICfnResourceOptionscfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsCfnOptionsICfnResourceOptionsrequired#cfnResourceTypestringcfn_resource_typestrcfnResourceTypeStringCfnResourceTypestringCfnResourceType*stringrequired#creationStackstring[]creation_stacktyping.List[str]creationStackList<String>CreationStackstring[]CreationStack*[]*stringrequired#excludedAccountsstring[]excluded_accountstyping.List[str]excludedAccountsList<String>ExcludedAccountsstring[]ExcludedAccounts*[]*string#The logical ID of the element is calculated from the path of the resource node in the construct tree.
To override this value, use overrideLogicalId(newLogicalId).
organizationConfigRuleNamestringorganization_config_rule_namestrorganizationConfigRuleNameStringOrganizationConfigRuleNamestringOrganizationConfigRuleName*stringrequired#organizationConfigRuleRefOrganizationConfigRuleReferenceorganization_config_rule_refOrganizationConfigRuleReferenceorganizationConfigRuleRefOrganizationConfigRuleReferenceOrganizationConfigRuleRefOrganizationConfigRuleReferenceOrganizationConfigRuleRefOrganizationConfigRuleReferencerequired#organizationCustomPolicyRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationCustomPolicyRuleMetadataPropertyorganization_custom_policy_rule_metadatatyping.Union[IResolvable, OrganizationCustomPolicyRuleMetadataProperty]organizationCustomPolicyRuleMetadataIResolvableOrganizationCustomPolicyRuleMetadataIResolvableOrganizationCustomPolicyRuleMetadatainterface{}#organizationCustomRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationCustomRuleMetadataPropertyorganization_custom_rule_metadatatyping.Union[IResolvable, OrganizationCustomRuleMetadataProperty]organizationCustomRuleMetadataIResolvableOrganizationCustomRuleMetadataIResolvableOrganizationCustomRuleMetadatainterface{}#organizationManagedRuleMetadataIResolvable | CfnOrganizationConfigRule.OrganizationManagedRuleMetadataPropertyorganization_managed_rule_metadatatyping.Union[IResolvable, OrganizationManagedRuleMetadataProperty]organizationManagedRuleMetadataIResolvableOrganizationManagedRuleMetadataIResolvableOrganizationManagedRuleMetadatainterface{}#If, by any chance, the intrinsic reference of a resource is not a string, you could coerce it to an IResolvable through Lazy.any({ produce: resource.ref }).
Methods
addDeletionOverride(path: string): voiddef add_deletion_override(self, path: str) -> Nonepublic void addDeletionOverride(String path)public void AddDeletionOverride(string path)func AddDeletionOverride(Path *string)#1 parameter
Parameters
pathpathpathpathPath— The path of the value to delete.
addDependency(target: CfnResource): voiddef add_dependency(self, target: CfnResource) -> Nonepublic void addDependency(CfnResource target)public void AddDependency(CfnResource target)func AddDependency(Target CfnResource)deprecated#This method has been renamed to addResourceDependency to more clearly set it apart from construct.node.addDependency. See the documentation of that function for more details.
addDependsOn(target: CfnResource): voiddef add_depends_on(self, target: CfnResource) -> Nonepublic void addDependsOn(CfnResource target)public void AddDependsOn(CfnResource target)func AddDependsOn(Target CfnResource)deprecated#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method has been renamed to addResourceDependency, which makes it more clear that this method operates at a different level from the construct-level construct.node.addDependency() mechanism.
addMetadata(key: string, value: any): voiddef add_metadata(self, key: str, value: Any) -> Nonepublic void addMetadata(String key, Object value)public void AddMetadata(string key, object value)func AddMetadata(Key *string, Value interface{})#addOverride(path: string, value: any): voiddef add_override(self, path: str, value: Any) -> Nonepublic void addOverride(String path, Object value)public void AddOverride(string path, object value)func AddOverride(Path *string, Value interface{})#notes · 2 parameters
To add a property override, either use addPropertyOverride or prefix path with "Properties." (i.e. Properties.TopicName).
If the override is nested, separate each nested level using a dot (.) in the path parameter. If there is an array as part of the nesting, specify the index in the path.
To include a literal . in the property name, prefix with a \. In most programming languages you will need to write this as "\\." because the \ itself will need to be escaped.
For example,
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
would add the overrides
"Properties": {
"GlobalSecondaryIndexes": [
{
"Projection": {
"NonKeyAttributes": [ "myattribute" ]
...
}
...
},
{
"ProjectionType": "INCLUDE"
...
},
]
...
}
The value argument to addOverride will not be processed or translated in any way. Pass raw JSON values in here with the correct capitalization for CloudFormation. If you pass CDK classes or structs, they will be rendered with lowercased key names, and CloudFormation will reject the template.
Parameters
pathpathpathpathPath— - The path of the property, you can use dot notation to override values in complex types.valuevaluevaluevalueValue— - The value.
addPropertyDeletionOverride(propertyPath: string): voiddef add_property_deletion_override(self, property_path: str) -> Nonepublic void addPropertyDeletionOverride(String propertyPath)public void AddPropertyDeletionOverride(string propertyPath)func AddPropertyDeletionOverride(PropertyPath *string)#1 parameter
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path to the property.
addPropertyOverride(propertyPath: string, value: any): voiddef add_property_override(self, property_path: str, value: Any) -> Nonepublic void addPropertyOverride(String propertyPath, Object value)public void AddPropertyOverride(string propertyPath, object value)func AddPropertyOverride(PropertyPath *string, Value interface{})#Syntactic sugar for addOverride("Properties.<...>", value).
2 parameters
Parameters
propertyPathproperty_pathpropertyPathpropertyPathPropertyPath— The path of the property.valuevaluevaluevalueValue— The value.
addResourceDependency(target: CfnResource, reason?: string): voiddef add_resource_dependency(self, target: CfnResource, reason: typing.Optional[str] = None) -> Nonepublic void addResourceDependency(CfnResource target, String reason)public void AddResourceDependency(CfnResource target, string? reason = null)func AddResourceDependency(Target CfnResource, Reason *string)#notes
This can be used for resources across stacks (or nested stack) boundaries and the dependency will automatically be transferred to the relevant scope.
This method only adds dependencies between L1 resources. If you are looking for a generic construct-to-construct dependency mechanism that works for all constructs including L2s, use construct.node.addDependency instead.
applyCrossStackReferenceStrength(strength: ReferenceStrength): voiddef apply_cross_stack_reference_strength(self, strength: ReferenceStrength) -> Nonepublic void applyCrossStackReferenceStrength(ReferenceStrength strength)public void ApplyCrossStackReferenceStrength(ReferenceStrength strength)func ApplyCrossStackReferenceStrength(Strength ReferenceStrength)#When set, any cross-stack reference to this resource will use the specified strength instead of the global default from the consuming stack's context.
1 parameter
Parameters
strengthstrengthstrengthstrengthStrength— - The reference strength to use for this resource.
applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): voiddef apply_removal_policy(self, policy: typing.Optional[RemovalPolicy] = None, options: typing.Optional[RemovalPolicyOptions] = None) -> Nonepublic void applyRemovalPolicy(RemovalPolicy policy, RemovalPolicyOptions options)public void ApplyRemovalPolicy(RemovalPolicy? policy = null, RemovalPolicyOptions? options = null)func ApplyRemovalPolicy(Policy RemovalPolicy, Options RemovalPolicyOptions)#notes
The Removal Policy controls what happens to this resource when it stops being managed by CloudFormation, either because you've removed it from the CDK application or because you've made a change that requires the resource to be replaced.
The resource can be deleted (RemovalPolicy.DESTROY), or left in your AWS account for data recovery and cleanup later (RemovalPolicy.RETAIN). In some cases, a snapshot can be taken of the resource prior to deletion (RemovalPolicy.SNAPSHOT). A list of resources that support this policy can be found in the following link:
arnForOrganizationConfigRule(resource: IOrganizationConfigRuleRef): string@staticmethod def arn_for_organization_config_rule(resource: IOrganizationConfigRuleRef) -> strpublic static String arnForOrganizationConfigRule(IOrganizationConfigRuleRef resource)public static string ArnForOrganizationConfigRule(IOrganizationConfigRuleRef resource)func ArnForOrganizationConfigRule(Resource IOrganizationConfigRuleRef) *stringstatic#cfnPropertyName(cdkPropertyName: string): stringdef cfn_property_name(self, cdk_property_name: str) -> strpublic String cfnPropertyName(String cdkPropertyName)public string CfnPropertyName(string cdkPropertyName)func CfnPropertyName(CdkPropertyName *string) *string#getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Referencedef get_att(self, attribute_name: str, type_hint: typing.Optional[ResolutionTypeHint] = None) -> Referencepublic Reference getAtt(String attributeName, ResolutionTypeHint typeHint)public Reference GetAtt(string attributeName, ResolutionTypeHint? typeHint = null)func GetAtt(AttributeName *string, TypeHint ResolutionTypeHint) Reference#Ideally, use generated attribute accessors (e.g. resource.arn), but this can be used for future compatibility in case there is no generated attribute.
1 parameter
Parameters
attributeNameattribute_nameattributeNameattributeNameAttributeName— The name of the attribute.
getMetadata(key: string): anydef get_metadata(self, key: str) -> Anypublic Object getMetadata(String key)public object GetMetadata(string key)func GetMetadata(Key *string) interface{}#inspect(inspector: TreeInspector): voiddef inspect(self, inspector: TreeInspector) -> Nonepublic void inspect(TreeInspector inspector)public void Inspect(TreeInspector inspector)func Inspect(Inspector TreeInspector)#1 parameter
Parameters
inspectorinspectorinspectorinspectorInspector— tree inspector to collect and process attributes.
isCfnElement(x: any): boolean@staticmethod def is_cfn_element(x: Any) -> boolpublic static Boolean isCfnElement(Object x)public static bool IsCfnElement(object x)func IsCfnElement(X interface{}) *boolstatic#Uses duck-typing instead of instanceof to allow stack elements from different versions of this library to be included in the same stack.
returns
Returns: The construct as a stack element or undefined if it is not a stack element.
isCfnOrganizationConfigRule(x: any): boolean@staticmethod def is_cfn_organization_config_rule(x: Any) -> boolpublic static Boolean isCfnOrganizationConfigRule(Object x)public static bool IsCfnOrganizationConfigRule(object x)func IsCfnOrganizationConfigRule(X interface{}) *boolstatic#isCfnResource(x: any): boolean@staticmethod def is_cfn_resource(x: Any) -> boolpublic static Boolean isCfnResource(Object x)public static bool IsCfnResource(object x)func IsCfnResource(X interface{}) *boolstatic#isConstruct(x: any): boolean@staticmethod def is_construct(x: Any) -> boolpublic static Boolean isConstruct(Object x)public static bool IsConstruct(object x)func IsConstruct(X interface{}) *boolstatic#notes · 1 parameter · returns
Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked.
Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.
Parameters
xxxxX— Any object.
Returns: true if x is an object created from a class which extends Construct.
obtainDependencies(): Stack | CfnResource[]def obtain_dependencies(self, ) -> typing.List[typing.Union[Stack, CfnResource]]public List<Stack> obtainDependencies()public Stack[] ObtainDependencies()func ObtainDependencies() *[]interface{}#For resources depended on directly, returns the CfnResource object. For dependencies on other stacks, returns the Stack object. The order of the array is not guaranteed.
overrideLogicalId(newLogicalId: string): voiddef override_logical_id(self, new_logical_id: str) -> Nonepublic void overrideLogicalId(String newLogicalId)public void OverrideLogicalId(string newLogicalId)func OverrideLogicalId(NewLogicalId *string)#1 parameter
Parameters
newLogicalIdnew_logical_idnewLogicalIdnewLogicalIdNewLogicalId— The new logical ID to use for this stack element.
removeDependency(target: CfnResource): voiddef remove_dependency(self, target: CfnResource) -> Nonepublic void removeDependency(CfnResource target)public void RemoveDependency(CfnResource target)func RemoveDependency(Target CfnResource)deprecated#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
removeResourceDependency(target: CfnResource): voiddef remove_resource_dependency(self, target: CfnResource) -> Nonepublic void removeResourceDependency(CfnResource target)public void RemoveResourceDependency(CfnResource target)func RemoveResourceDependency(Target CfnResource)#This can be used for resources across stacks (including nested stacks) and the dependency will automatically be removed from the relevant scope.
replaceDependency(target: CfnResource, newTarget: CfnResource): voiddef replace_dependency(self, target: CfnResource, new_target: CfnResource) -> Nonepublic void replaceDependency(CfnResource target, CfnResource newTarget)public void ReplaceDependency(CfnResource target, CfnResource newTarget)func ReplaceDependency(Target CfnResource, NewTarget CfnResource)#2 parameters
Parameters
targettargettargettargetTarget— The dependency to replace.newTargetnew_targetnewTargetnewTargetNewTarget— The new dependency to add.
toString(): stringdef to_string(self, ) -> strpublic String toString()public string ToString()func ToString() *string#returns
Returns: a string representation of this resource
with(...mixins: IMixin[]): IConstructdef with(self, mixins: IMixin) -> IConstructpublic IConstruct with(IMixin mixins)public IConstruct With(IMixin mixins)func With(Mixins IMixin) IConstruct#Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.